Subject: [Sip] Re: [Simple] -05 MESSAGE and Expires header

From: Ben Campbell <[email-masked]>
Date: Tue, 16 Jul 2002 19:29:22 -0500

Yes--this was pretty much the mood of the room in the SIMPLE wg meeting. 
It was also mentioned that this is a SIP draft, and any decisions must 
be made on the SIP list. (I am copying this message to SIP).

So, my current plan is to leave it alone. If others disagree, please 
express that on the SIP list.

Thanks!

Ben.

Cullen Jennings wrote:
> To quote the honorable Mr. Sparks "leave it alone"
> 
> I don't think that it is fundamentally broken (other than of course the lame
> name). Priority is definitely not the right thing to use. I would vote for
> just going with it as it is.
> 
> Cullen
> 
> 
> 
>>-----Original Message-----
>>From: [email-masked]
>>[mailto:[email-masked]]On Behalf Of Vijay K.
>>Gurbani
>>Sent: Tuesday, July 16, 2002 5:39 AM
>>To: [email-masked]
>>Cc: [email-masked]
>>Subject: [Simple] -05 MESSAGE and Expires header
>>
>>
>>Ben:
>>
>>Any reasons why -05 MESSAGE I-D overloads "Expires: 0" to mean
>>immediate attention.  Maybe we can use "Priority: Urgent" instead; since
>>the Priority header is defined in 3261 and "may be factored into
>>decisions about call routing and acceptance".
>>
>>I think that overloading the Expires header here is confusing; 3261's
>>use of "Expires: 0" in conjunction with REGISTER means something
>>entirely different -- that this registration is invalid.  From a
>>semantic point of view, "Expires: 0" with REGISTER to mean
>>deregistration appears to make sense; but "Expires: 0" with MESSAGE to
>>mean immediate delivery appears incongrous.
>>
>>If it is not too late, maybe you can consider using the Priority header.
>>I won't be able to make it to simple WG meeting tomorrow, so I just
>>wanted to bring this to you attention.
>>
>>Thanks,
>>
>>- vijay
>>
>>_______________________________________________
>>simple mailing list
>>[email-masked]
>>http://mailman.dynamicsoft.com/mailman/listinfo/simple
>>
> 
> 

_______________________________________________
Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
This list is for NEW development of the core SIP Protocol
Use [email-masked] for questions on current sip
Use [email-masked] for new developments on the application of sip

---

From: [email-masked]
Date: Tue, 23 Jul 2002 10:51:24 +0300

I would like some interpretation for a few messages in terms of immediate delivery, urgency and expiration of a message:

1.
MESSAGE ...
Priority: non-urgent
Expires: 0
...
I'm leaving for lunch right now

2.
MESSAGE ...
Priority: emergency
Expires: 3600
...
your house is on fire

3.
MESSAGE ...
...
Date: Tue, 23 Jul 2002 7:25:00 GMT
Expires: 60

4.
MESSAGE ...
...
Date: Tue, 23 Jul 2002 7:25:00 GMT
Expires: 0

Do messages 1 and 2 get immediate delivery?

Another question: This immediate delivery debate is only talking about Store and Forward type of servers of gateways. What about other intermediaries? They certainly can't use the expires-header to decide on speed of delivery of a message. We need a new mechanism here. Again I ask the question: Is this done in IEPREP?

Regards,
Hisham

> From: ext Sean Olson [mailto:[email-masked]]
> Sent: Tuesday, July 23, 2002 9:39 AM
> To: Khartabil Hisham (NMP/Helsinki); [email-masked];
> [email-masked]
> Cc: [email-masked]; [email-masked]
> Subject: RE: [Sip] Re: [Simple] -05 MESSAGE and Expires header
> 
> 
> I fail to see why Expires: 0 means the message
> will never expire. How does 0 equate to infinity?
> 
> An Expires: 0 from the sender, in my opinion,
> should indicate that this message should be delivered
> immediately or not at all. I don't think it should
> be used for the sender (or gateway or proxy) to
> indicate that a message is "stale".
> 
> By stale,
> I assume you mean a message that was intended for
> immediate delivery, but was actually stored instead
> -- this is not something existing SIP headers do a
> good job of representing. I wouldn't try to hack
> Expires: to fit this. Furthermore, I don't think
> this is a problem that the message draft should have
> to solve. Until someone comes up with a more complete
> draft for offline message retrieval, I think we can
> punt this. Or is that what you were offering to do?
> 
> 
> --- [email-masked] wrote:
> > So, a MESSAGE with Expires: 10 means it has 10
> > seconds before it's stale while a MESSAGE with
> > Expires: 0 means it will never be stale?
> > 
> > How do u inform the receiver that a message is
> > stale?
> > 
> > /Hisham
> > 
> > > From: ext Sean Olson [mailto:[email-masked]]
> > > Sent: Monday, July 22, 2002 8:07 PM
> > > To: Ben Campbell; Vijay K. Gurbani
> > > Cc: Adam Roach; SIP LIST
> > > Subject: Re: [Sip] Re: [Simple] -05 MESSAGE and
> > Expires header
> > > 
> > > 
> > > So we have three things we might want to 
> > > represent:
> > > 
> > > 1) Priority -- we use the Priority header for this
> > > 2) Timeliness of content -- we use Expires: header
> > >    for this
> > > 3) Urgency -- we don't currently have a way to 
> > >    represent this
> > > 
> > > Obviously 2 & 3 are related but not identical.
> > > The message doesn't have to be urgent in order
> > > for you to request immediate delivery. I think
> > > solving (2) is enough for now. It is the more
> > > interesting case for gateways and other
> > > intermediaries that have to decide between a 
> > > store-and-forward or immediate delivery approach.
> > > In other words, stick with what we have today in
> > > the draft.
> > > 
> > > /sean
> > > 
> > > __________________________________________________
> > > Do You Yahoo!?
> > > Yahoo! Health - Feel better, live better
> > > http://health.yahoo.com
> > > 
> > > Sip mailing list 
> > https://www1.ietf.org/mailman/listinfo/sip
> __________________________________________________
> Do You Yahoo!?
> Yahoo! Health - Feel better, live better
> http://health.yahoo.com
>

---

From: "Drage, Keith (Keith)" <[email-masked]>
Date: Tue, 23 Jul 2002 19:53:15 +0100

To the best of my knowledge, emergency calls have no more requirement for immediate delivery over and above any other SIP call.

There is a requirement of guarantee of reliable delivery to an appropriate emergency service answer point. In the case of local network congestion, all callers, including callers of the emergency service, will have equal difficulty in getting their INVITE through.

IEPREP is not dealing with emergency service, IEPREP is dealing with the ability of preferential authenticated callers to make calls at times of an emergency with preferential allocation of resources to make that call possible. These could potentially additionally be emergency service calls, but are more likely to be the chief of fire service calling local water supply chief or any other similar form of communication.

IEPREP is also meant to state requirements. Therefore any decision on what the protocol does in any particular condition, and what protocol is required to meet the requirements, rests with SIP, not with IEPREP, even when the issue is an IEPREP requirements statement.

Keith

> From: [email-masked] [mailto:[email-masked]]
> Sent: 23 July 2002 08:51
> To: [email-masked]; [email-masked]; [email-masked]
> I would like some interpretation for a few messages in terms 
> of immediate delivery, urgency and expiration of a message:
> 
> 1.
> MESSAGE ...
> Priority: non-urgent
> Expires: 0
> ...
> Another question: This immediate delivery debate is only 
> talking about Store and Forward type of servers of gateways. 
> What about other intermediaries? They certainly can't use the 
> expires-header to decide on speed of delivery of a message. 
> We need a new mechanism here. Again I ask the question: Is 
> this done in IEPREP?
> 
> Regards,
> Hisham
>

---

From: Adam Roach <[email-masked]>
Date: Wed, 24 Jul 2002 11:03:06 -0500

> We don't want the expires-header to be used as a source for 
> routing decisions. We also don't want to special case "expires: 0".
> 
> Why should routing depend on the value on the expires header?

Proxies can route on whatever makes sense for them. If I want
a proxy to route based on whether some string appears in the
Subject field, I can. If I want it to route based on a hash
of the SDP, I can. If I want it to route based on the second
digit of the hour portion of the date field, I can. You can
argue that such things might not be useful (and I'll agree)
but a proxy can make routing decisions based on whatever
makes sense for whatever service they are designed to provide.

So, if I (as a service provider) want to deploy a node that
bases its behavior on the "Expires" header -- either because
it makes sense for me, or provides a wanted service for my
users -- then that's what I'm going to do. I don't think
the MESSAGE spec needs to mention this in any way, though.

(As an analogy, 3261 does not mention anything about making
routing decisions based on the "Accept-Language" field --
but you can certainly imagine circumstances in which it would
make sense to do so).

> I think the best thing to do is to remove the text. Other 
> methods don't define the meaning of "Expires: 0".

Except section 10.2.2 of RFC 3261 (REGISTER).

And section 3.1.4.3 of RFC 3265 (SUBSCRIBE).

While "Expires: 0" isn't a special case, it is (obviously)
cause for confusion (otherwise we wouldn't have a huge
discussion thread spanning two mailing lists arguing about
its meaning). So, from a purely theoretical perspective,
your point has some validity: the meaning of "Expires: 0"
*can* be deduced using rigorous and consistent thinking.

However, from a *practical* perspective, it's obvious that
some people would get the semantics of "Expires: 0" wrong
unless there is some guidance provided -- and varying
semantics will harm interoperability. I argue for a
consistent handling, but explicit text the clarifies
the issue to leave no room for misinterpretation.

I further argue that the current document already satisifies
this request.

/a